var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import joi from '@hapi/joi';
import { simplePseudos } from './transformCSS';
var cssPropertiesSchema = joi
    .object()
    .pattern(joi.string().regex(/^[^:@]/), [joi.string(), joi.number()]);
var keyframesSchema = joi.object().pattern(joi.string(), cssPropertiesSchema);
var cssWithKeyframesSchema = cssPropertiesSchema.append({
    '@keyframes': [joi.string(), keyframesSchema],
});
var cssWithSimplePseudos = cssWithKeyframesSchema.append(Object.assign.apply(Object, __spreadArrays([{}], simplePseudos.map(function (pseudo) {
    var _a;
    return (_a = {}, _a[pseudo] = cssWithKeyframesSchema, _a);
}))));
var selectorsSchema = joi
    .object()
    .pattern(joi.string(), cssWithKeyframesSchema);
var fullStyle = cssWithSimplePseudos.append({
    selectors: selectorsSchema,
});
var makeMediaQuerySchema = function (valueSchema) {
    return valueSchema.append({
        '@media': joi.object().pattern(joi.string(), valueSchema),
    });
};
var fullStyleWithMedia = makeMediaQuerySchema(fullStyle).required();
var globalStyleWithMedia = makeMediaQuerySchema(fullStyle).required();
var validate = function (handler) { return function (value) {
    var error = handler.validate(value).error;
    if (error !== null) {
        console.error(error);
    }
}; };
export var validateGlobalStyle = validate(globalStyleWithMedia);
export var validateStyle = validate(fullStyleWithMedia);
